﻿using CascadingCombobox.EF;
using System.Collections.Generic;
using System.Linq;

namespace CascadingCombobox
{
    public class DAL
    {
        public static List<Country> GetCountries()
        {
            using (TestingModel dbContext = new TestingModel())
            {
                List<Country> countries = dbContext
                    .ca_countries
                    .Select(m=>new Country
                    {
                        CountryId = m.country_id,
                        CountryName = m.name
                    }).ToList();

                return countries;
            }
        }

        public static List<State> GetStates(int countryId)
        {
            using (TestingModel dbContext = new TestingModel())
            {
                List<State> countries = dbContext
                    .ca_states
                    .Where(c => c.country_id == countryId)
                    .Select(m => new State
                    {
                        StateId = m.state_id,
                        StateName = m.name
                    }).ToList();

                return countries;
            }
        }

        public static List<City> GetCities(int stateId)
        {
            using (TestingModel dbContext = new TestingModel())
            {
                List<City> countries = dbContext
                    .ca_cities
                    .Where(c => c.state_id == stateId)
                    .Select(m => new City
                    {
                        CityId = m.city_id,
                        CityName = m.name
                    }).ToList();

                return countries;
            }
        }
    }

    public class Country
    {
        public int CountryId { get; set; }
        public string CountryName { get; set; }
    }

    public class State
    {
        public int StateId { get; set; }
        public string StateName { get; set; }
    }

    public class City
    {
        public int CityId { get; set; }
        public string CityName { get; set; }
    }
}